import os
import ConfigParser

import pytest

def pytest_addoption(parser):
    parser.addoption('--without-postgresql-tests', action='store_true',
                    help='disable tests requiring postgresql')

def pytest_runtest_setup(item):
    if 'postgresql' in item.keywords and item.config.option.without_postgresql_tests is True:
        pytest.skip('skipped (PostgreSQL are disabled on command line)')

def variable_url(request, pub, variable, url):
    config = ConfigParser.ConfigParser()
    path = os.path.join(pub.app_dir, 'site-options.cfg')
    if os.path.exists(path):
        config.read([path])
    if not config.has_section('options'):
        config.add_section('options')
    config.set('options', variable, url)
    with file(path, 'w') as site_option:
        config.write(site_option)

    def fin():
        config = ConfigParser.ConfigParser()
        if os.path.exists(path):
            config.read([path])
            config.remove_option('options', variable)
            with file(path, 'w') as site_option:
                config.write(site_option)
    request.addfinalizer(fin)
    return url

@pytest.fixture
def fargo_url(request, pub):
    return variable_url(request, pub, 'fargo_url', 'http://fargo.example.net')

@pytest.fixture
def welco_url(request, pub):
    return variable_url(request, pub, 'welco_url', 'http://welco.example.net')
